## tcltrf 2.1.3

=== DESCRIPTION ===
# -*- tcl -*-

extension trf {
    description {
	A loadable extension to Tcl providing commands for data conversion,
	message digests, zlib based compression, error-correction,
	channel-based manipulation of binary data.

	Trf extends the language at the C-level with so-called
	``transformer''-procedures. With the help of some patches (*) to the
	core the package is able to intercept all read/write operations
	on designated channels, thus giving it the ability to transform
	the buffer contents as desired. This allows things like
	transparent encryption, compression, charset recoding,
	etc. Build upon this framework (and as proof of concept) a
	collection of tcl-level commands was implemented. Additionally
	some binary data support is put in as well.

	A separate package containing encryption transformation is available
	at the same site carrying this package.

	(*) The patches are only necessary for Tcl 8.0.x and 8.1.x. Since
	Tcl 8.2 the Trf patch is an official part of the core.
    }

    keywords {
	tcl, conversion, message digests,
	data compression, error-correction, binary io, crc, md2, md5,
	sha, sha-1, haval, adler, ripemd-160, dual, hexadecimal, octal,
	uuencode, base64, ascii85, reed-solomon, zlib, otp_md5, otp_sha1,
	otp_words
    }

    author       {Andreas Kupries (andreas_kupries@users.sourceforge.net)}
    maintenance  {Andreas Kupries (andreas_kupries@users.sourceforge.net)}

    version	   2.1.3
    copying-policy {BSD-Style, see 'tcl'-license}
    date           {DEC-06-2008}

    primary-urls {
	http://tcltrf.sourceforge.net/
    }

    development-platform {Linux 2.0.29, gcc 2.7.2.3}
    platforms {
	Linux 2.0.29	(gcc 2.7.2.3)	Development system
	IRIX 6.2	(cc only)
	ULTRIX 4.1	(both cc and gcc)
	ULTRIX 4.4	(cc 3.0)
	HP-UX-9		(both cc and gcc)
	HP-UX-10.2
	Solaris 2.5	(gcc only)

	Other machines and OS's should work too. 
    }

    dependencies {
	tcl 8.0 or higher,
	plus-patches as of Dec 5, 1996 or later (optional),
	memchan 1.0 or higher (required by testsuite),
	zlib-1.0.4 or higher (optional, 1.2.4 is current),
    }
}

## tcltrf 2.1.4

=== DESCRIPTION ===
--- 
+++ 
@@ -34,9 +34,9 @@
     author       {Andreas Kupries (andreas_kupries@users.sourceforge.net)}
     maintenance  {Andreas Kupries (andreas_kupries@users.sourceforge.net)}
 
-    version	   2.1.3
+    version	   2.1.4
     copying-policy {BSD-Style, see 'tcl'-license}
-    date           {DEC-06-2008}
+    date           {MAY-06-2009}
 
     primary-urls {
 	http://tcltrf.sourceforge.net/

=== generic/sha/Makefile ===
# By default, the code is compiled for a "big endian" machine.
# To compile on a "little endian" machine set the LITTLE_ENDIAN flag.
# To make smaller object code, but run a little slower, don't use UNROLL_LOOPS.
# To use NIST's modified SHA of 7/11/94, define USE_MODIFIED_SHA

CC = gcc
CFLAGS = -O2 -ansi -Wall -pedantic -DUNROLL_LOOPS -DLITTLE_ENDIAN # -DUSE_MODIFIED_SHA

all:	sha

sha:	sha_driver.o sha.o
	$(CC) -o $@ sha_driver.o sha.o
	strip $@

test:	sha appgen
	appgen 1 | sha
	appgen 2 | sha
	appgen 3 | sha
	@echo "Values should be:"
	@cat sha.good.outputs
	@echo "except if you defined USE_MODIFIED_SHA!"
	@echo "I have no known-good comparisons for that case!"

clean:
	rm *.o sha appgen

## tcltrf 2.1.4-dfsg3

=== debian/changelog ===
tcltrf (2.1.4-dfsg3-8) unstable; urgency=medium

  * Fix FTBFS on 32-bit architectures.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 05 Mar 2025 17:18:59 +0300

tcltrf (2.1.4-dfsg3-7) unstable; urgency=medium

  * Fix processing --enable-static-* configure options with newer
    autoconf. This fixes segmentation fault in calculation of md5 hash.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 05 Mar 2025 14:40:42 +0300

tcltrf (2.1.4-dfsg3-6) unstable; urgency=medium

  * Fix FTBFS with GCC 15 (closes: #1097973).
  * Mark tcl-trf-doc as multi-arch foreign.
  * Bump standards version to 4.7.2.

 -- Sergei Golovan <sgolovan@debian.org>  Tue, 04 Mar 2025 20:41:48 +0300

tcltrf (2.1.4-dfsg3-5) unstable; urgency=medium

  * Fix FTBFS with GCC 14 for 32-bit architectures (closes: #1075553).

 -- Sergei Golovan <sgolovan@debian.org>  Sun, 28 Jul 2024 19:26:40 +0300

tcltrf (2.1.4-dfsg3-4) unstable; urgency=medium

  * Fix FTBFS with GCC 14 (closes: #1075553).
  * Bump standards version to 4.7.0.

 -- Sergei Golovan <sgolovan@debian.org>  Sun, 28 Jul 2024 12:21:27 +0300

tcltrf (2.1.4-dfsg3-3) unstable; urgency=medium

  * Fix implicit declaration of the crypt() function (closes: #1065954).
  * Drop doc-base support.
  * Drop unused lintian overrides.
  * Bump the debhelper compatibility level to 13.
  * Bump standards version to 4.6.2.

 -- Sergei Golovan <sgolovan@debian.org>  Tue, 12 Mar 2024 08:20:59 +0300

tcltrf (2.1.4-dfsg3-2.1) unstable; urgency=medium

  * Non maintainer upload by the Reproducible Builds team.
  * No source change upload to rebuild on buildd with .buildinfo files.

 -- Holger Levsen <holger@debian.org>  Tue, 05 Jan 2021 00:58:12 +0100

tcltrf (2.1.4-dfsg3-2) unstable; urgency=low

  * Completed reimplementing of MD2 hash (configure script still searched for
    the md2.h file). This helps with FTBFS if build using upcoming OpenSSL 1.1.
  * Explicitly specified openssl, zlib and bz2 headers and libs location
    because the configure script couldn't find them without a hint.
  * Bumped standards version to 3.9.8.

 -- Sergei Golovan <sgolovan@debian.org>  Sun, 12 Jun 2016 10:28:40 +0300

tcltrf (2.1.4-dfsg3-1) unstable; urgency=low

  * Replaced non-free RIPEMD-128 and RIPEMD-160 implementations by free
    ones, offered by Legimet (closes: #751879).
  * Fixed HAVAL hash calculation for 64-bit architectures.
  * Converted the package to the 3.0 (quilt) source format.
  * Multiarchified the package. Bumped the debhelper compatibility level to 9.
  * Bumped standards version to 3.9.5.
  * Overridden lintian warnings on ancient autotools helper files because
    they aren't used when building the package.

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 21 Jun 2014 10:18:06 +0400

tcltrf (2.1.4-dfsg2-1) unstable; urgency=low

  * Removed non-DFSG-free painless-guide-to-crc.txt from the source tarball
    (closes: #688021).
  * Bumped standards version to 3.9.4.

 -- Sergei Golovan <sgolovan@debian.org>  Mon, 26 Aug 2013 11:58:42 +0400

tcltrf (2.1.4-dfsg1-1) unstable; urgency=low

  * Removed non-DFSG-free msvcrt.dll from the source tarball (closes: #685207).

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 18 Aug 2012 14:37:06 +0400

tcltrf (2.1.4-dfsg-3) unstable; urgency=low

  * Reimplemented MD2 hash after it was removed from the OpenSSL
    implementation (closes: #664713).
  * Removed conflict of tcl-trf-doc with libtrf-tcl and libtrf-tcl-dev.
  * Added build-arch and build-indep targets to debian/rules (closes: #648491).
  * Added ${misc:Depends} to the dependencies of tcl-trf-doc because of
    debhelper requirement.
  * Bumped standards version to 3.9.3.

 -- Sergei Golovan <sgolovan@debian.org>  Tue, 27 Mar 2012 13:55:30 +0400

tcltrf (2.1.4-dfsg-2) unstable; urgency=low

  * Fixed bug with putting library and documentation files into binary
    packages.
  * Switched to prebuilt docs (closes: #562383).
  * Added README.source which explains how to manage patched sources using
    quilt patch system.

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 26 Dec 2009 00:57:59 +0300

tcltrf (2.1.4-dfsg-1) unstable; urgency=low

  * New upstream release.
  * Renamed binary packages to tcl-trf, tcl-trf-dev and tcl-trf-doc to comply
    Debian Tcl/Tk policy.
  * Changed behavior of md5crypt command to retain magic $1$ at the beginning
    of its result.
  * Added README.source where it is described how to apply the series of
    patches to an original taeball.
  * Bumped standards version to 3.8.3.

 -- Sergei Golovan <sgolovan@debian.org>  Tue, 03 Nov 2009 11:42:57 +0300

tcltrf (2.1.3-dfsg-2) unstable; urgency=low

  * Upload to unstable.
  * Replaced explicit sf.net download server in debian/watch file by sf
    redirector.

 -- Sergei Golovan <sgolovan@debian.org>  Sun, 01 Mar 2009 14:09:20 +0300

tcltrf (2.1.3-dfsg-1) experimental; urgency=low

  * Removed non-free code (haval and haval.1996 subdirectories).
  * Mangle debian version in uscan control file.

 -- Sergei Golovan <sgolovan@debian.org>  Mon, 22 Dec 2008 18:27:17 +0300

tcltrf (2.1.3-1) experimental; urgency=low

  * New upstream release.
  * Protected quilt invocations to make the source package convertible to
    format 3.0 (quilt) (closes: #484925).
  * Bumped standards version to 3.8.0.

 -- Sergei Golovan <sgolovan@debian.org>  Sun, 21 Dec 2008 14:21:54 +0300

tcltrf (2.1.2~20071113-2) unstable; urgency=low

  * Removed c2man from build-dependencies.

 -- Sergei Golovan <sgolovan@debian.org>  Mon, 05 May 2008 00:37:13 +0400

tcltrf (2.1.2~20071113-1) unstable; urgency=low

  * New CVS snapshot with a few bugfixes.
  * Pregenerated C-API manpages and HTML docs to remove build-dependency on
    c2man, which is outdated and subject ro removal from Debian
    (closes: #478650, #478722).
  * Fixed clean target to work with debhelper 7.0 (made dh_clean the last
    command, so debhelper logs are removed now).
  * Bumped standards version to 3.7.3.


=== debian/control ===
Source: tcltrf
Section: interpreters
Priority: optional
Maintainer: Sergei Golovan <sgolovan@debian.org>
Build-Depends: debhelper-compat (= 13), zlib1g-dev (>= 1:1.2.1), libbz2-dev (>= 1.0.2), libssl-dev, libcrypt-dev, tcl-dev (>= 8.6.0+2)
Standards-Version: 4.7.2
Homepage: http://tcltrf.sourceforge.net/

Package: tcl-trf
Architecture: any
Section: libs
Multi-Arch: same
Depends: libtcl, ${shlibs:Depends}, ${misc:Depends}
Conflicts: libtrf-tcl
Provides: libtrf-tcl
Suggests: tcl-trf-doc
Description: Tcl data transformations - runtime library
 Trf is an extension to Tcl which provides various data
 transformations. The collection of provided transformation
 procedures includes:
  * generation of message digests (hash values, checksums): MD2,
    MD5, SHA/SHS, SHA-1, HAVAL, RIPEMD-128, -160, CRC (polynomial
    used by PGP), Adler (based upon zlib);
  * conversion to and from various data encodings: uuencoding,
    base64-encoding, or ASCII85-encoding, and binary, octal, or
    hexadecimal representation;
  * an error-correcting Reed-Solomon encoder/decoder;
  * compression/decompression based on zlib and libbz2.
 .
 This package contains the runtime library to be used in Tcl programs.

Package: tcl-trf-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: tcl-trf (= ${binary:Version}), tcl-dev, ${shlibs:Depends}, ${misc:Depends}
Conflicts: libtrf-tcl-dev
Provides: libtrf-tcl-dev
Suggests: tcl-trf-doc
Description: Tcl data transformations - development files
 Trf is an extension to Tcl which provides various data
 transformations. The collection of provided transformation
 procedures includes:
  * generation of message digests (hash values, checksums): MD2,
    MD5, SHA/SHS, SHA-1, HAVAL, RIPEMD-128, -160, CRC (polynomial
    used by PGP), Adler (based upon zlib);
  * conversion to and from various data encodings: uuencoding,
    base64-encoding, or ASCII85-encoding, and binary, octal, or
    hexadecimal representation;
  * an error-correcting Reed-Solomon encoder/decoder;
  * compression/decompression based on zlib and libbz2.
 .
 This package contains files to be used for development of C-based
 extensions which use the Trf library.

Package: tcl-trf-doc
Architecture: all
Section: doc
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: tcl-trf
Conflicts: libtrf-tcl-doc
Replaces: libtrf-tcl, libtrf-tcl-dev, libtrf-tcl-doc
Provides: libtrf-tcl-doc
Description: Tcl data transformations - documentation
 Trf is an extension to Tcl which provides various data
 transformations. The collection of provided transformation
 procedures includes:
  * generation of message digests (hash values, checksums): MD2,
    MD5, SHA/SHS, SHA-1, HAVAL, RIPEMD-128, -160, CRC (polynomial
    used by PGP), Adler (based upon zlib);
  * conversion to and from various data encodings: uuencoding,
    base64-encoding, or ASCII85-encoding, and binary, octal, or
    hexadecimal representation;
  * an error-correcting Reed-Solomon encoder/decoder;
  * compression/decompression based on zlib and libbz2.
 .
 This package contains manual pages and HTML documentation for Trf commands
 and C-API.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

version = 2.1.4
cvsdate = 20071113

DIR=$(CURDIR)/debian/tmp

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk

%:
	dh $@

override_dh_auto_clean:
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -f test.setup

override_dh_auto_configure:
	CFLAGS="$(CFLAGS) -DSSL_STATIC_BUILD=1 -D_XOPEN_SOURCE" \
	SHLIB_SUFFIX=.so \
	no_zlibtcl=true \
	dh_auto_configure -- \
		--with-tcl=/usr/lib \
		--with-tclinclude=/usr/include/tcl \
		--enable-static-zlib \
		--enable-static-bzlib \
		--enable-static-md5 \
		--with-ssl-include-dir=/usr/include/openssl \
		--with-ssl-lib-dir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--with-zlib-include-dir=/usr/include \
		--with-zlib-lib-dir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--with-bz2-include-dir=/usr/include \
		--with-bz2-lib-dir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--enable-threads

override_dh_auto_build:
	$(MAKE) LIBS="-lz -lbz2 -lcrypt -lcrypto"

override_dh_auto_install:
	$(MAKE) install DESTDIR=$(DIR)
	install -m 755 -d $(DIR)/usr/lib/tcltk/$(DEB_HOST_MULTIARCH)
	mv $(DIR)/usr/lib/$(DEB_HOST_MULTIARCH)/Trf* $(DIR)/usr/lib/tcltk/$(DEB_HOST_MULTIARCH)
	#
	mkdir -p $(DIR)/usr/share/doc/html $(DIR)/usr/share/doc/man
	# Cleanup manpages
	cd doc/man && \
	  for f in *.n ; do \
	    sed -e'/^\.so man.macros/ d' \
	    	-e'/^\.BS/ d' \
	    	-e'/^\.BE/ d' \
	    	-e's/^\.TH \([^ ]\+\) n/.TH \1 3trf/' \
		$$f >$(DIR)/usr/share/doc/man/`basename $$f .n`.3trf || exit 1; \
	  done
	#
	# Cleanup docs
	cd doc/html && \
	  for f in *.html ; do \
	    sed -e's/(n)/(3trf)/g' $$f >$(DIR)/usr/share/doc/html/$$f || exit 1; \
	  done
	#
	# c2man is outdated and removed from Debian. So, a pregenerated manpages
	# and HTML docs are used.
	# A liitle hack to make c2man working
	#cd generic && c2man -D__builtin_va_list=int -DBUFSIZ -I/usr/include/tcl -o../doc/capi/man -Tn transform.h
	#cd generic && c2man -D__builtin_va_list=int -DBUFSIZ -I/usr/include/tcl -o../doc/capi/html -Th transform.h
	#
	# Generate documentation indices
	tclsh debian/gen_index.tcl $(DIR)/usr/share/doc/html doc/capi/html \
	      >$(DIR)/usr/share/doc/html/index.html

override_dh_auto_test:
	# make test doesn't work currently.

override_dh_shlibdeps:
	tcltk-depends -a
	dh_shlibdeps -a

get-orig-source: get-orig-source-release

get-orig-source-release:
	CURDIR=`pwd` && TMPDIR=`mktemp -d /tmp/tcltrf.XXXXXX` && \
	cd $$TMPDIR && \
	wget -O - http://heanet.dl.sourceforge.net/sourceforge/tcltrf/trf$(version).tar.gz | tar zx && \
	rm -rfv trf$(version)/generic/haval \
		trf$(version)/generic/haval.1996 \
		trf$(version)/generic/ripemd \
		trf$(version)/win/msvcrt.dll \
		trf$(version)/doc/painless-guide-to-crc.txt && \
	tar -zcf $$CURDIR/tcltrf_$(version)-dfsg3.orig.tar.gz trf$(version) && \
	rm -rf $$TMPDIR

get-orig-source-cvs:
	CURDIR=`pwd` && \
	TMPDIR=`mktemp -d /tmp/tcltrf.XXXXXX` && \
	SCRDIR=`dirname $(MAKEFILE_LIST)` && \
	expect $$SCRDIR/checkout \
	       :pserver:anonymous@tcltrf.cvs.sourceforge.net:/cvsroot/tcltrf \
	       trf \
	       $$TMPDIR "$(cvsdate)T23:59:59" && \
	echo "Removing CVS stuff and non-free files" && \
	find $$TMPDIR -name '*.orig' \
		      -o -name CVS \
		      -o -name msvcrt.dll \
		      -o -name mpexpand \
		      -o -name patches \
		      -o -name zlib.vc \
		      -o -name painless-guide-to-crc.txt \
		      -o -name haval \
		      -o -name haval.1996 \
		      -o -name ripemd \
		      -o -name mails | xargs rm -rvf && \
	cd $$TMPDIR && \
	tar -zcf $$CURDIR/tcltrf_$(version)~$(cvsdate)-dfsg3.orig.tar.gz . && \
	rm -rf $$TMPDIR

.PHONY: override_dh_auto_clean override_dh_auto_configure override_dh_auto_install override_dh_auto_test \
	override_dh_shlibdeps get-orig-source get-orig-source-release get-orig-source-cvs
